<template>
  <div>
    <Modal v-model="showEditModal" v-drag :mask-closable="false" :width="500" class="zIndex-1200">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="100" inline>
          <Form-item label="库房号" prop="warehouse" style="width: 100%">
            <Input v-model="formObj.warehouse" name="warehouse" placeholder="请输入库房号"/>
          </Form-item>
          <Form-item label="货架号" prop="name" style="width: 100%">
            <Input v-model="formObj.name" name="name" placeholder="请输入货架号"/>
          </Form-item>
          <Form-item label="位置分类:" prop="type" style="width: 100%">
            <Select v-model="formObj.type" clearable name="type" placeholder="请选择类别">
              <Option v-for="(item,index) in typeData" :value="item.value" :key="index">{{item.name}}</Option>
            </Select>
          </Form-item>
          <Form-item label="位置管理人" prop="manager" style="width: 100%">
            <Input v-model="formObj.manager" @click.native="_selectStaff" name="manager" readonly/>
          </Form-item>
          <Form-item prop="managerId" style="width: 100%;display: none">
            <Input v-model="formObj.managerId" @click.native="_selectStaff" name="managerId" readonly/>
          </Form-item>
          <Form-item label="备注说明" prop="remark" style="width: 100%">
            <Input v-model="formObj.remark" name="remark" placeholder="请输入备注说明"/>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <ModalFooter ref="footerModal" @on-result-change="_footerResult" :footer="footerList"></ModalFooter>
      </div>
    </Modal>
    <UserInfo ref="userModal" @on-result-change="_userData" is-change></UserInfo>
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import ModalFooter from '../../../components/base/modalFooter'
import { soilSample } from '../../../api'
import Global from '../../../api/config'
import UserInfo from '../../../components/user-info-single/assignPerson'

export default {
  components: {
    ModalFooter,
    UserInfo
  },
  data() {
    return {
      formId: '',
      lengthLimitList: [
        { key: 'stdNum', title: '标准号' },
        { key: 'enName', title: '英文名称' },
        { key: 'belongUnit', title: '归口单位' },
        { key: 'publishUnit', title: '发布单位' }
      ],
      modalTitle: '收样位置选择',
      formObj: {
        name: '',
        warehouse: '',
        type: '',
        remark: '',
        manager: '',
        managerId: ''
      },
      options: [
        {
          name: '国家标准'
        },
        {
          name: '地方标准'
        },
        {
          name: '行业标准'
        },
        {
          name: '企业标准'
        }
      ],
      typeData: [
        {
          name: '待检',
          value: 0
        },
        {
          name: '备样',
          value: 1
        },
        {
          name: '备用',
          value: 2
        }
      ],
      ruleValidate: {
        warehouse: [
          { required: true, message: '库房号不能为空', trigger: 'blur' }
        ],
        name: [{ required: true, message: '架位号不能为空', trigger: 'blur' }]
      },
      showEditModal: false,
      classifyList: [
        { value: 0, name: '判定依据' },
        { value: 1, name: '检测依据' },
        { value: 2, name: '其他' }
      ],
      typeList: [
        { value: 0, name: '国家标准' },
        { value: 1, name: '地方标准' },
        { value: 2, name: '行业标准' },
        { value: 3, name: '企业标准' }
      ],
      statusList: [
        { value: 0, name: '现行' },
        { value: 1, name: '即将实施' },
        { value: 2, name: '部分被代替' },
        { value: 3, name: '被代替' },
        { value: 4, name: '作废' }
      ],
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ]
    }
  },
  methods: {
    _getUser() {
      const user = Global.getUserInfo()
      this.formObj.manager = user.realname
      this.formObj.managerId = user.id
      console.log(user)
    },
    _selectStaff() {
      this.$refs.userModal._open()
    },
    _userData(data, msg, contractTempData) {
      this.formObj.manager = data.realname
      this.formObj.managerId = data.id
      console.log(data, msg)
    },
    /** *modal-footer */
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(msg) {
      this.showEditModal = false
      this.$Message.success(msg)
      this.$emit('on-result-change')
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          if (this.formObj.publishDate && this.formObj.effectDate) {
            if (this.formObj.publishDate > this.formObj.effectDate) {
              this.$Message.error('发布日期应早于实施日期')
              this._hideLoading()
              return
            }
          }
          const data = this.$serialize('edit-form')
          if (this.$string(this.formObj.id).isEmpty()) {
            // 添加
            console.log('data', data)
            this._save(data)
          } else {
            // 编辑
            this._edit({ id: this.formObj.id, obj: data })
          }
        } else {
          this.$Message.error('表单验证失败!')
          this._hideLoading()
        }
      })
    },
    _save: async function(data) {
      const result = await soilSample.aloneWarehouseLocationAdd(data)
      if (result) {
        this._resultChange('添加成功!')
      }
    },
    _edit: async function(data) {
      const result = await soilSample.aloneWarehouseLocationEdit(data)
      if (result) {
        this._resultChange('编辑成功!')
      }
    },
    _cancel() {
      this._hideLoading()
      this.showEditModal = false
    },
    _open(formObj) {
      this.formId = this.$randomCode()
      this._hideLoading()
      this.$refs.formObj.resetFields()
      if (this.$string(formObj).isEmpty()) {
        this.modalTitle = '添加'
        this.formObj.id = ''
        this._getUser()
      } else {
        this.formObj = formObj
        this.formObj.id = formObj.id
        this.formObj.effectDate = this.formObj.effectDate
          ? new Date(formObj.effectDate)
          : ''
        this.formObj.publishDate = this.formObj.publishDate
          ? new Date(formObj.publishDate)
          : ''
        this.modalTitle = '编辑'
      }
      this.showEditModal = true
    },
    _registerAdd() {
      this.formId = this.$randomCode()
      this._hideLoading()
      this.$refs.formObj.resetFields()
      this.modalTitle = '添加'
      this.formObj.id = ''
      this.formObj.type = 3
      this.showEditModal = true
    }
  }
}
</script>
